/////////////////////////////////////////////////////////////////////////////
// Name:        sampledialog.h
// Purpose:     
// Author:      Julian Smart
// Modified by: 
// Created:     23/04/2009 21:57:42
// RCS-ID:      
// Copyright:   
// Licence:     
/////////////////////////////////////////////////////////////////////////////

#ifndef _SAMPLEDIALOG_H_
#define _SAMPLEDIALOG_H_


/*!
 * Includes
 */

////@begin includes
#include "wx/notebook.h"
#include "wx/tglbtn.h"
#include "wx/hyperlink.h"
#include "wx/spinctrl.h"
#include "wx/srchctrl.h"
#include "wx/html/htmlwin.h"
#include "wx/dirctrl.h"
#include "wx/richtext/richtextctrl.h"
#include "wx/treectrl.h"
////@end includes

#include "ax/ax_ui_adaptation.h"

/*!
 * Forward declarations
 */

////@begin forward declarations
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_SAMPLEDIALOG 10001
#define ID_NOTEBOOK 10018
#define ID_PANEL 10019
#define ID_TEXTCTRL 10003
#define ID_TEXTCTRL1 10004
#define ID_LISTBOX 10005
#define ID_COMBOBOX 10006
#define ID_BUTTON 10007
#define ID_BITMAPBUTTON 10008
#define ID_TOGGLEBUTTON 10013
#define ID_CHECKBOX1 10009
#define ID_RADIOBUTTON 10010
#define ID_HYPERLINKCTRL 10014
#define ID_SPINCTRL 10011
#define ID_SLIDER 10012
#define ID_SEARCHCTRL 10022
#define ID_PANEL1 10020
#define ID_HTMLWINDOW 10016
#define ID_DIRCTRL 10017
#define ID_RICHTEXTCTRL 10021
#define ID_TREECTRL 10015
#define SYMBOL_SAMPLEDIALOG_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX|wxTAB_TRAVERSAL
#define SYMBOL_SAMPLEDIALOG_TITLE _("Sample Self Voiced Dialog")
#define SYMBOL_SAMPLEDIALOG_IDNAME ID_SAMPLEDIALOG
#define SYMBOL_SAMPLEDIALOG_SIZE wxSize(400, 300)
#define SYMBOL_SAMPLEDIALOG_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * SampleDialog class declaration
 */

class SampleDialog: public wxDialog
{    
    DECLARE_DYNAMIC_CLASS( SampleDialog )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    SampleDialog();
    SampleDialog( wxWindow* parent, wxWindowID id = SYMBOL_SAMPLEDIALOG_IDNAME, const wxString& caption = SYMBOL_SAMPLEDIALOG_TITLE, const wxPoint& pos = SYMBOL_SAMPLEDIALOG_POSITION, const wxSize& size = SYMBOL_SAMPLEDIALOG_SIZE, long style = SYMBOL_SAMPLEDIALOG_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_SAMPLEDIALOG_IDNAME, const wxString& caption = SYMBOL_SAMPLEDIALOG_TITLE, const wxPoint& pos = SYMBOL_SAMPLEDIALOG_POSITION, const wxSize& size = SYMBOL_SAMPLEDIALOG_SIZE, long style = SYMBOL_SAMPLEDIALOG_STYLE );

    /// Destructor
    ~SampleDialog();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

////@begin SampleDialog event handler declarations

////@end SampleDialog event handler declarations

////@begin SampleDialog member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end SampleDialog member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin SampleDialog member variables
////@end SampleDialog member variables

    AxSelfVoicing m_adapter;
};

#endif
    // _SAMPLEDIALOG_H_
