/////////////////////////////////////////////////////////////////////////////
// Name:        ax_document.cpp
// Purpose:     Accessibility classes: AxDocument
// Author:      Julian Smart
// Modified by:
// Created:     2009-03-20
// RCS-ID:
// Copyright:   (c) Julian Smart
// Licence:     New BSD License
/////////////////////////////////////////////////////////////////////////////

#include "wx/wx.h"

#include "ax/ax_document.h"

/*
 * AxDocument implementation.
 * A document can represent a tool, file, web site, etc.
 */

IMPLEMENT_CLASS( AxDocument, wxEvtHandler )

AxDocument::~AxDocument()
{
}

void AxDocument::Init()
{
    m_modified = false;
}

// Copy the basic information.
void AxDocument::Copy(const AxDocument& doc)
{
    m_modified = doc.m_modified;
}

// Test equality for the basic information
bool AxDocument::Eq(const AxDocument& doc) const
{
    return (m_modified == doc.m_modified);
}
